<script lang="ts">
  import { onMount } from 'svelte';
  import * as d3 from 'd3';
  import { fetchClaims } from '$lib';

  // queryInput contains the input in the date selectors
  let queryInput: {
    registrationFrom: string;
    registrationTo: string;
    validFrom: string;
    validTo: string;
  } = {
    validFrom: '2000-01-01T00:00',
    validTo: '2012-01-31T00:00',
    registrationFrom: '2000-01-01T00:00',
    registrationTo: '2050-01-31T00:00',
  };

  // Set the dimensions and margins of the graph
  const margin = { top: 10, right: 20, bottom: 40, left: 50 },
    width = 450 - margin.left - margin.right,
    height = 400 - margin.top - margin.bottom;

  async function drawChart() {
    console.log('fetching with query input:', queryInput);

    // Scope to which the selection is limited
    let scope: { v_from: Date; v_to: Date; r_from: Date; r_to: Date } = {
      v_from: new Date(queryInput.validFrom),
      v_to: new Date(queryInput.validTo),
      r_from: new Date(queryInput.registrationFrom),
      r_to: new Date(queryInput.registrationTo),
    };

    // Clean up the (possibly) previously added SVG
    d3.select('#graph').selectAll('*').remove();

    // Append the svg object to the element
    const svg = d3
      .select('#graph')
      .append('svg')
      .attr('width', width + margin.left + margin.right)
      .attr('height', height + margin.top + margin.bottom)
      // Add the remove button as symbol
      .html(
        '<symbol id="remove-button" width="20" height="20" viewBox="0 0 24 24"><path fill="#fff" d="M12 4c-4.41 0-8 3.59-8 8s3.59 8 8 8s8-3.59 8-8s-3.59-8-8-8m5 11.59L15.59 17L12 13.41L8.41 17L7 15.59L10.59 12L7 8.41L8.41 7L12 10.59L15.59 7L17 8.41L13.41 12z"></path><path fill="currentColor" d="M12 2C6.47 2 2 6.47 2 12s4.47 10 10 10s10-4.47 10-10S17.53 2 12 2m0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8s8 3.59 8 8s-3.59 8-8 8m3.59-13L12 10.59L8.41 7L7 8.41L10.59 12L7 15.59L8.41 17L12 13.41L15.59 17L17 15.59L13.41 12L17 8.41z"></path></symbol>',
      )
      // Translate this svg element to leave some margin
      .append('g')
      .attr('transform', 'translate(' + margin.left + ',' + margin.top + ')');

    // Add a tooltip
    const tooltip = d3.select('#graph').append('div').attr('id', 'tooltip');

    // Functions that change the tooltip when user hover / move / leave a cell
    function mouseover(_: MouseEvent) {
      tooltip.style('opacity', '1');
      d3.select('this').style('stroke', 'black').style('opacity', 1);
    }

    function mousemove({ target }: MouseEvent) {
      const data = target?.__data__; // IMPROVE: get the data in a TypeScript-safe way
      let toolTipData = `id: ${data.id}
        kind: ${data.kind}
        type: ${data.type}
        subject: ${data.subject}
        claimant: ${data.claimant}
        data: ${JSON.stringify(data.data)}
        st: ${JSON.stringify(data.registrationFrom)}
        ed: ${JSON.stringify(data.registrationTo)}
        operation: ${data.associatedOperation}
        annotations: ${data.annotatingClaims.length}`.replace(/\n[\w]?/g, '<br>');

      toolTipData += '<ul>';

      for (const annotation of data.annotatingClaims) {
        toolTipData += `<li> ${annotation.kind} ${annotation.id}</li>`;
      }
      toolTipData += '</ul>';

      tooltip.html(toolTipData);
    }

    function mouseleave(_: MouseEvent) {
      tooltip.style('opacity', '0');
      d3.select('this').style('stroke', 'none').style('opacity', 0.8);
    }

    // Load the data
    const responseData = await fetchClaims(
      'Voornaam',
      queryInput.registrationFrom,
      queryInput.registrationTo,
      queryInput.validFrom,
      queryInput.validTo,
    );

    // Parse the data
    const parsedData: {
      id: string;
      type: string;
      kind: string;
      subject: string;
      claimant: string;
      data: { name: string; id: string };
      annotatingClaims: { kind: string; id: string }[];
      associatedOperation: string | null;
      label: string;
      registrationFrom: Date;
      registrationTo: Date | null;
      validFrom: Date | null;
      validTo: Date | null;
    }[] = responseData.data.map((item) => ({
      id: item.id,
      type: item.type,
      kind: item.kind,
      subject: item.subject,
      claimant: item.claimant,
      data: item.data,
      annotatingClaims: item.annotatingClaims,
      label: `${item.data.name || '<Onbekend>'} (${item.data.id})`,
      associatedOperation: item.associatedOperation || 'N/A',
      registrationFrom: d3.isoParse(item.registrationStart)!,
      registrationTo: d3.isoParse(item.registrationEnd || ''),
      validFrom: d3.isoParse(item.validStart || ''),
      validTo: d3.isoParse(item.validEnd || ''),
    })).filter((item) => item.kind != 'ExpireValid' && item.kind != 'ExpireRegistration');

    // X scale
    const x = d3.scaleTime(
      [scope.v_from, scope.v_to], // Domain: the min and the max of the data
      [0, width], // Range: the corresponding values in pixels
    );

    // Y scale
    const y = d3.scaleTime(
      [scope.r_from, scope.r_to], // Domain: the min and the max of the data
      [height, 0], // Range: the corresponding values in pixels
    );

    // X and Y axes. Note: see https://www.d3indepth.com/axes/ for more options
    svg
      .append('g')
      .attr('id', 'xaxis')
      .attr('transform', 'translate(0,' + height + ')')
      .call(d3.axisBottom(x))
      .selectAll('text')
      .attr('transform', 'translate(-10,0) rotate(-45)')
      .style('text-anchor', 'end');

    svg.append('g').attr('id', 'yaxis').call(d3.axisLeft(y));

    // Add the rectangles (i.e. claims) to the chart
    svg
      .selectAll('.claim')
      .data(parsedData) // Bind data to selection
      .enter() // Enter the updated selection
      .append('rect') // Append a rectangle for each data point
      .attr('class', (d) => `claim ${d.kind}`)
      .attr('x', (d) => x(maxDate(d.validFrom || scope.v_from, scope.v_from))) // Start date
      .attr('y', (d) => y(minDate(d.registrationTo || scope.r_to, scope.r_to))) // End date
      .attr(
        'width',
        (d) =>
          x(minDate(d.validTo || scope.v_to, scope.v_to)) -
          x(maxDate(d.validFrom || scope.v_from, scope.v_from)), // IMPROVE: get from the x attribute?
      ) // End date minus start date
      .attr(
        'height',
        (d) =>
          y(maxDate(d.registrationFrom, scope.r_from)) -
          y(minDate(d.registrationTo || scope.r_to, scope.r_to)), // IMPROVE: get from the y attribute?
      ) // Start date minus end date
      .on('mouseover', mouseover)
      .on('mousemove', mousemove)
      .on('mouseleave', mouseleave)
      .each((data, i) => {
        // For rectangles with null start/end times (i.e. infinity) or with start/end times that exceed the graph area, add a dashed line on top of its borders
        if (!data.validFrom || data.validFrom < scope.v_from) {
          svg
            .insert('line', `rect:nth-of-type(${i + 2})`) // Insert before the next claim rectangle
            .attr('class', 'earlierValidFrom')
            .attr('x1', x(scope.v_from))
            .attr('x2', x(scope.v_from))
            .attr('y1', y(maxDate(data.registrationFrom || scope.r_from, scope.r_from)))
            .attr('y2', y(minDate(data.registrationTo || scope.r_to, scope.r_to)));
        }

        if (!data.validTo || data.validTo > scope.v_to) {
          svg
            .insert('line', `rect:nth-of-type(${i + 2})`)
            .attr('class', 'laterValidTo')
            .attr('x1', x(scope.v_to))
            .attr('x2', x(scope.v_to))
            .attr('y1', y(maxDate(data.registrationFrom || scope.r_from, scope.r_from)))
            .attr('y2', y(minDate(data.registrationTo || scope.r_to, scope.r_to)));
        }

        if (data.registrationFrom < scope.r_from) {
          svg
            .insert('line', `rect:nth-of-type(${i + 2})`)
            .attr('class', 'earlierRegistrationFrom')
            .attr('x1', x(maxDate(data.validFrom || scope.v_from, scope.v_from)))
            .attr('x2', x(minDate(data.validTo || scope.v_to, scope.v_to)))
            .attr('y1', y(scope.r_from))
            .attr('y2', y(scope.r_from));
        }

        if (!data.registrationTo || data.registrationTo > scope.r_to) {
          svg
            .insert('line', `rect:nth-of-type(${i + 2})`)
            .attr('class', 'laterRegistrationTo')
            .attr('x1', x(maxDate(data.validFrom || scope.v_from, scope.v_from)))
            .attr('x2', x(minDate(data.validTo || scope.v_to, scope.v_to)))
            .attr('y1', y(scope.r_to))
            .attr('y2', y(scope.r_to));
        }
      });

    // Add rectangle labels
    svg
      .selectAll('.label')
      .data(parsedData)
      .enter()
      .append('text')
      .attr('class', 'label')
      .attr('text-anchor', 'middle')
      .attr(
        'x',
        (d) =>
          (x(maxDate(d.validFrom || scope.v_from, scope.v_from)) +
            x(minDate(d.validTo || scope.v_to, scope.v_to))) /
          2,
      )
      .attr(
        'y',
        (d) =>
          (y(maxDate(d.registrationFrom || scope.r_from, scope.r_from)) +
            y(minDate(d.registrationTo || scope.r_to, scope.r_to))) /
          2,
      )
      .attr('dy', '5px')
      .text((d) => d.label);

    // Add annotation markers
    svg
      .selectAll('.annotation-markers')
      .data(parsedData.filter((d) => d.annotatingClaims.length > 0))
      .enter()
      .append('g')
      .attr('class', 'annotation-markers')
      .selectAll('circle')
      .data((d) =>
        d.annotatingClaims
        .filter((d) => d.kind != "ExpireValid" && d.kind != "ExpireRegistration")
        .map((claim) => ({
          validFrom: d.validFrom,
          registrationTo: d.registrationTo,
          annotatingClaim: claim,
        })),
      )
      .enter()
      .append('circle')
      .attr('class', (d) => `annotation-marker ${d.annotatingClaim.kind}`)
      .attr('cx', (d, i) => x(d.validFrom || scope.v_from) + 10 * (i + 1))
      .attr('cy', (d) => y(d.registrationTo || scope.r_to) + 10)
      .attr('r', '5px');

    // Axis labels
    svg
      .append('text')
      .attr('text-anchor', 'end')
      .attr('x', width)
      .attr('y', height + 38)
      .attr('dx', '-.25em')
      .style('font-size', '12px')
      .text('Materieel (validiteit)');

    svg
      .append('text')
      .attr('text-anchor', 'end')
      .attr('y', -50)
      .attr('dy', '.75em')
      .attr('dx', '-.25em')
      .attr('transform', 'rotate(-90)')
      .style('font-size', '12px')
      .text('Formeel (registratie)');

    // Handle hovering and clicking axes
    let xSelected: number | undefined = undefined;
    let ySelected: number | undefined = undefined;

    const horizontalLine1 = svg
      .append('line')
      .attr('class', 'selection-line')
      .attr('x1', 0)
      .attr('y1', 0)
      .attr('x2', width)
      .attr('y2', 0);

    const horizontalLine2 = svg
      .append('line')
      .attr('class', 'selection-line')
      .attr('x1', 0)
      .attr('y1', 0)
      .attr('x2', width)
      .attr('y2', 0);

    const verticalLine1 = svg
      .append('line')
      .attr('class', 'selection-line')
      .attr('x1', 0)
      .attr('y1', 0)
      .attr('x2', 0)
      .attr('y2', height);

    const verticalLine2 = svg
      .append('line')
      .attr('class', 'selection-line')
      .attr('x1', 0)
      .attr('y1', 0)
      .attr('x2', 0)
      .attr('y2', height)
      .style('display', 'none');

    const area = svg
      .append('rect')
      .attr('fill', 'rgba(29, 78, 216, 0.25)') // blue-800/25
      .attr('x', 0)
      .attr('y', 0)
      .attr('width', width)
      .attr('height', height)
      .style('display', 'none');

    d3.select('#xaxis')
      .on('mouseover', () => {
        verticalLine1.style('display', 'block');
      })
      .on('mousemove', handleMoveX)
      .on('click', handleClickX)
      .on('mouseout', () => {
        verticalLine1.style('display', 'none');
        area.style('display', 'none').attr('x', 0).attr('width', width);
      });

    d3.select('#yaxis')
      .on('mouseover', () => {
        horizontalLine1.style('display', 'block');
      })
      .on('mousemove', handleMoveY)
      .on('click', handleClickY)
      .on('mouseout', () => {
        horizontalLine1.style('display', 'none');
        area.style('display', 'none').attr('y', 0).attr('height', height);
      });

    const xIndicator = svg
      .append('use')
      .attr('id', 'xindicator')
      .attr('href', '#remove-button')
      .on('click', () => {
        xSelected = undefined;

        verticalLine2.style('display', 'none');
        area.style('display', 'none');
        xIndicator.style('display', 'none');
      });

    const yIndicator = svg
      .append('use')
      .attr('id', 'xindicator')
      .attr('href', '#remove-button')
      .on('click', () => {
        ySelected = undefined;

        horizontalLine2.style('display', 'none');
        area.style('display', 'none');
        yIndicator.style('display', 'none');
      });

    function handleMoveX({ offsetX }: MouseEvent) {
      const posX = offsetX - margin.left;

      verticalLine1.attr('x1', posX);
      verticalLine1.attr('x2', posX);

      if (xSelected) {
        // Show an area between the lines
        area
          .attr('x', Math.min(posX, xSelected))
          .attr('width', Math.abs(posX - xSelected))
          .style('display', 'block');
      }
    }

    function handleMoveY({ offsetY }: MouseEvent) {
      const posY = offsetY - margin.top;

      horizontalLine1.attr('y1', posY);
      horizontalLine1.attr('y2', posY);

      if (ySelected) {
        // Show an area between the lines
        area
          .attr('y', Math.min(posY, ySelected))
          .attr('height', Math.abs(posY - ySelected))
          .style('display', 'block');
      }
    }

    function handleClickX({ offsetX }: PointerEvent) {
      const posX = offsetX - margin.left;

      if (xSelected === undefined) {
        // Set a fixed line at the click position
        verticalLine2.attr('x1', posX).attr('x2', posX).style('display', 'block');

        // Add an indicator
        xIndicator
          .attr('x', posX - 10)
          .attr('y', height + 5)
          .style('display', 'block');

        xSelected = posX;
      } else {
        const date1 = x.invert(xSelected);
        const date2 = x.invert(posX);

        // Zoom on the X axis
        queryInput = {
          ...queryInput,
          validFrom: dateToLocalDateTime(minDate(date1, date2)),
          validTo: dateToLocalDateTime(maxDate(date1, date2)),
        };
      }
    }

    function handleClickY({ offsetY }: PointerEvent) {
      const posY = offsetY - margin.top;

      if (ySelected === undefined) {
        // Set a fixed line at the click position
        horizontalLine2.attr('y1', posY).attr('y2', posY).style('display', 'block');

        // Add an indicator
        yIndicator
          .attr('x', -25)
          .attr('y', posY - 10)
          .style('display', 'block');

        ySelected = posY;
      } else {
        const date1 = y.invert(ySelected);
        const date2 = y.invert(posY);

        // Zoom on the Y axis
        queryInput = {
          ...queryInput,
          registrationFrom: dateToLocalDateTime(minDate(date1, date2)),
          registrationTo: dateToLocalDateTime(maxDate(date1, date2)),
        };
      }
    }
  }

  let isMounted = false;

  onMount(() => {
    isMounted = true;
    drawChart();
  });

  function minDate(a: Date, b: Date): Date {
    if (a < b) {
      return a;
    }

    return b;
  }

  function maxDate(a: Date, b: Date): Date {
    if (a > b) {
      return a;
    }

    return b;
  }

  // function roundDateToNearestHour(date: Date) {
  //   const roundedDate = new Date(date);
  //   roundedDate.setMinutes(0);
  //   roundedDate.setSeconds(0);
  //   roundedDate.setMilliseconds(0);
  //   return roundedDate;
  // }

  // function roundDateToNearestDay(date: Date) {
  //   const roundedDate = new Date(date);
  //   roundedDate.setHours(0, 0, 0, 0); // Set hours, minutes, seconds, and milliseconds to zero
  //   return roundedDate;
  // }

  // dateToLocalDateTime converts the specified date to a string in the format required for <input type="datetime-local">
  const dateToLocalDateTime = d3.utcFormat('%Y-%m-%dT%H:%M'); // Note: can be rounded/truncated by replacing `%M` with `00`

  // Update the chart when the input changes
  $: updateChart(
    queryInput.registrationFrom,
    queryInput.registrationTo,
    queryInput.validFrom,
    queryInput.validTo,
  );

  function updateChart(_: string, __: string, ___: string, ____: string) {
    if (isMounted) {
      drawChart();
    }
  }
</script>

<svelte:head>
  <title>Historical data visualizer</title>
</svelte:head>

<div class="p-4">
  <div id="queryinput" class="mb-5 grid grid-cols-3 gap-5 md:grid-cols-6">
    <label
      class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2"
      for="registration-from"
    >
      Registratie start
    </label>
    <input
      id="registration-from"
      bind:value={queryInput.registrationFrom}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="datetime-local"
    />

    <label
      class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2"
      for="registration-to"
    >
      Registratie eind
    </label>
    <input
      id="registration-to"
      bind:value={queryInput.registrationTo}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="datetime-local"
    />

    <label class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2" for="valid-from">
      Validiteit start
    </label>
    <input
      id="valid-from"
      bind:value={queryInput.validFrom}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="datetime-local"
    />

    <label class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2" for="valid-to">
      Validiteit eind
    </label>
    <input
      id="valid-to"
      bind:value={queryInput.validTo}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="datetime-local"
    />
  </div>

  <div id="graph"></div>
</div>

<style lang="postcss">
  :global(#tooltip) {
    @apply mt-5 rounded-md bg-slate-600 p-4 font-mono text-sm text-white opacity-0;
  }

  :global(#graph .claim),
  :global(#graph .annotation-marker) {
    @apply cursor-pointer fill-slate-300 stroke-slate-800 hover:fill-slate-400;
  }

  :global(#graph .annotation-marker) {
    @apply pointer-events-none fill-slate-300 stroke-slate-800;
  }

  :global(#graph .claim.Assertion),
  :global(#graph .annotation-marker.Assertion) {
    @apply fill-blue-300 hover:fill-blue-400;
  }

  :global(#graph .claim.Correction),
  :global(#graph .annotation-marker.Correction) {
    @apply fill-yellow-300 hover:fill-yellow-400;
  }

  :global(#graph .claim.Refutation),
  :global(#graph .annotation-marker.Refutation) {
    @apply fill-rose-300 hover:fill-rose-400;
  }

  :global(
      #graph .earlierValidFrom,
      #graph .laterValidTo,
      #graph .earlierRegistrationFrom,
      #graph .laterRegistrationTo
    ) {
    @apply stroke-white;
    stroke-dasharray: 3 3;
  }

  :global(#graph .label) {
    @apply pointer-events-none text-[9px];
  }

  :global(#graph #xaxis, #graph #yaxis) {
    @apply cursor-pointer;
    pointer-events: bounding-box; /* Apply mouseover to the surrounding box instead of to the individual group children */
  }

  :global(#graph .selection-line) {
    @apply hidden stroke-blue-800 stroke-2 opacity-50;
    stroke-dasharray: 4 4;
  }

  :global(#graph #xindicator),
  :global(#graph #yindicator) {
    @apply hidden cursor-pointer text-slate-500 hover:text-rose-600;
    pointer-events: bounding-box;
  }
</style>
